import java.util.ArrayList;
import java.util.List;

/**
 * Board for the Scribble game
 *
 * @author hajo
 */
public class Board {

    // Use arrays because board newer change (but some waste of space)
    private final Tile[][] tiles;

    public Board(int rows, int cols) {
        tiles = new Tile[rows][cols];
    }

    public boolean add(int row, int col, Tile tile) {
        if (tiles[row][col] == null) {
            tiles[row][col] = tile;
            return true;
        } else {
            return false;
        }
    }

    public Tile remove(int row, int col) {
        Tile t = tiles[row][col];
        if (t.isFrozen()) {
            tiles[row][col] = null;
            return t;
        } else {
            return null;
        }
    }

    public List<Tile> removeTemps() {
        List<Tile> temps = new ArrayList<>();
        for (int row = 0; row < tiles.length; row++) {
            for (int col = 0; col < tiles[row].length; col++) {
                if (tiles[row][col].isFrozen()) {
                    temps.add(tiles[row][col]);
                    tiles[row][col] = null;
                }
            }
        }
        return temps;
    }

    // Make tiles non-removable
    public void freezeTiles() {
        for (int row = 0; row < tiles.length; row++) {
            for (int col = 0; col < tiles[row].length; col++) {
                if (tiles[row][col] != null) {
                    tiles[row][col].freeze();
                }
            }
        }
    }

    public boolean tilesCorrectlyPlaced() {
        return true; // For now!
    }

    public Tile[][] getTiles() {
        return tiles;
    }
}
